jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
| 40 | tmp_dir="${TMPDIR}/$USER/${test_dir}" |
| 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | export JAVA="java" |
Brian Carlstrom | 5103ce6 | 2014-03-30 16:17:42 -0700 | [diff] [blame] | 44 | export JAVAC="javac -g" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 45 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 46 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 47 | export NEED_DEX="true" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 48 | export USE_JACK="false" |
Alex Light | 8a0e033 | 2015-10-26 10:11:58 -0700 | [diff] [blame] | 49 | export SMALI_ARGS="--experimental --api-level 23" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 50 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 51 | # If dx was not set by the environment variable, assume it is in the path. |
| 52 | if [ -z "$DX" ]; then |
| 53 | export DX="dx" |
| 54 | fi |
| 55 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 56 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 57 | if [ -z "$JASMIN" ]; then |
| 58 | export JASMIN="jasmin" |
| 59 | fi |
| 60 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 61 | # If smali was not set by the environment variable, assume it is in the path. |
| 62 | if [ -z "$SMALI" ]; then |
| 63 | export SMALI="smali" |
| 64 | fi |
| 65 | |
| 66 | # If dexmerger was not set by the environment variable, assume it is in the path. |
| 67 | if [ -z "$DXMERGER" ]; then |
| 68 | export DXMERGER="dexmerger" |
| 69 | fi |
| 70 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 71 | # If jack was not set by the environment variable, assume it is in the path. |
| 72 | if [ -z "$JACK" ]; then |
| 73 | export JACK="jack" |
| 74 | fi |
| 75 | |
| 76 | # If the tree is compiled with Jack, build test with Jack by default. |
| 77 | if [ "$ANDROID_COMPILE_WITH_JACK" = "true" ]; then |
| 78 | USE_JACK="true" |
| 79 | fi |
| 80 | |
| 81 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 82 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 83 | export ANDROID_BUILD_TOP=$oldwd |
| 84 | fi |
| 85 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 86 | # If JACK_CLASSPATH is not set, assume it only contains core-libart. |
| 87 | if [ -z "$JACK_CLASSPATH" ]; then |
| 88 | export JACK_CLASSPATH="$ANDROID_BUILD_TOP/out/host/common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack" |
| 89 | fi |
| 90 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 91 | # If JILL_JAR is not set, assume it is located in the prebuilts directory. |
| 92 | if [ -z "$JILL_JAR" ]; then |
| 93 | export JILL_JAR="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/jill.jar" |
| 94 | fi |
| 95 | |
| 96 | export JACK="$JACK -g -cp $JACK_CLASSPATH" |
| 97 | export JILL="java -jar $JILL_JAR" |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 98 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 99 | info="info.txt" |
| 100 | build="build" |
| 101 | run="run" |
| 102 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 103 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 104 | output="output.txt" |
| 105 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 106 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 107 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 108 | lib="libartd.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 109 | testlib="arttestd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 110 | run_args="--quiet" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 111 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 112 | |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 113 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 114 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 115 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 116 | dev_mode="no" |
| 117 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 118 | debug_mode="no" |
| 119 | relocate="yes" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 120 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 121 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 122 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 123 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 124 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 125 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 126 | basic_verify="false" |
| 127 | gc_verify="false" |
| 128 | gc_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 129 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 130 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 131 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 132 | have_dex2oat="yes" |
| 133 | have_patchoat="yes" |
| 134 | have_image="yes" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 135 | image_suffix="" |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 136 | pic_image_suffix="" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 137 | android_root="/system" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 138 | |
| 139 | while true; do |
| 140 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 141 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 142 | DEX_LOCATION=$tmp_dir |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 143 | run_args="${run_args} --host" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 144 | shift |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 145 | elif [ "x$1" = "x--use-java-home" ]; then |
| 146 | if [ -n "${JAVA_HOME}" ]; then |
| 147 | export JAVA="${JAVA_HOME}/bin/java" |
| 148 | export JAVAC="${JAVA_HOME}/bin/javac -g" |
| 149 | else |
| 150 | echo "Passed --use-java-home without JAVA_HOME variable set!" |
| 151 | usage="yes" |
| 152 | fi |
| 153 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 154 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 155 | target_mode="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 156 | runtime="jvm" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 157 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 158 | NEED_DEX="false" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 159 | USE_JACK="false" |
Nicolas Geoffray | 288a4a2 | 2014-10-07 11:02:40 +0100 | [diff] [blame] | 160 | run_args="${run_args} --jvm" |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 161 | build_args="${build_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 162 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 163 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 164 | lib="libart.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 165 | testlib="arttest" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 166 | shift |
| 167 | elif [ "x$1" = "x--dalvik" ]; then |
| 168 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 169 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 170 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 171 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 172 | have_dex2oat="no" |
| 173 | shift |
| 174 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 175 | have_patchoat="no" |
| 176 | shift |
| 177 | elif [ "x$1" = "x--no-image" ]; then |
| 178 | have_image="no" |
| 179 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 180 | elif [ "x$1" = "x--pic-image" ]; then |
| 181 | pic_image_suffix="-pic" |
| 182 | shift |
| 183 | elif [ "x$1" = "x--pic-test" ]; then |
| 184 | run_args="${run_args} --pic-test" |
| 185 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 186 | elif [ "x$1" = "x--relocate" ]; then |
| 187 | relocate="yes" |
| 188 | shift |
| 189 | elif [ "x$1" = "x--no-relocate" ]; then |
| 190 | relocate="no" |
| 191 | shift |
| 192 | elif [ "x$1" = "x--prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 193 | run_args="${run_args} --prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 194 | prebuild_mode="yes" |
| 195 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 196 | elif [ "x$1" = "x--debuggable" ]; then |
| 197 | run_args="${run_args} -Xcompiler-option --debuggable" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 198 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 199 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 200 | elif [ "x$1" = "x--no-prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 201 | run_args="${run_args} --no-prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 202 | prebuild_mode="no" |
| 203 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 204 | elif [ "x$1" = "x--gcverify" ]; then |
| 205 | basic_verify="true" |
| 206 | gc_verify="true" |
| 207 | shift |
| 208 | elif [ "x$1" = "x--gcstress" ]; then |
| 209 | basic_verify="true" |
| 210 | gc_stress="true" |
| 211 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 212 | elif [ "x$1" = "x--image" ]; then |
| 213 | shift |
| 214 | image="$1" |
| 215 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 216 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 217 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 218 | shift |
| 219 | option="$1" |
| 220 | run_args="${run_args} -Xcompiler-option $option" |
| 221 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 222 | elif [ "x$1" = "x--runtime-option" ]; then |
| 223 | shift |
| 224 | option="$1" |
| 225 | run_args="${run_args} --runtime-option $option" |
| 226 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 227 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 228 | shift |
| 229 | gdb_arg="$1" |
| 230 | run_args="${run_args} --gdb-arg $gdb_arg" |
| 231 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 232 | elif [ "x$1" = "x--debug" ]; then |
| 233 | run_args="${run_args} --debug" |
| 234 | shift |
| 235 | elif [ "x$1" = "x--gdb" ]; then |
| 236 | run_args="${run_args} --gdb" |
| 237 | dev_mode="yes" |
| 238 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 239 | elif [ "x$1" = "x--strace" ]; then |
| 240 | strace="yes" |
| 241 | run_args="${run_args} --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output" |
| 242 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 243 | elif [ "x$1" = "x--zygote" ]; then |
| 244 | run_args="${run_args} --zygote" |
| 245 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 246 | elif [ "x$1" = "x--interpreter" ]; then |
| 247 | run_args="${run_args} --interpreter" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 248 | image_suffix="-interpreter" |
| 249 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 250 | elif [ "x$1" = "x--jit" ]; then |
| 251 | run_args="${run_args} --jit" |
Andreas Gampe | 8a159fd | 2015-09-21 15:14:38 -0700 | [diff] [blame] | 252 | image_suffix="-jit" |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 253 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 254 | elif [ "x$1" = "x--optimizing" ]; then |
| 255 | run_args="${run_args} -Xcompiler-option --compiler-backend=Optimizing" |
| 256 | image_suffix="-optimizing" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 257 | shift |
Nicolas Geoffray | c9338b9 | 2014-12-03 13:36:10 +0000 | [diff] [blame] | 258 | elif [ "x$1" = "x--quick" ]; then |
| 259 | run_args="${run_args} -Xcompiler-option --compiler-backend=Quick" |
| 260 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 261 | elif [ "x$1" = "x--no-verify" ]; then |
| 262 | run_args="${run_args} --no-verify" |
| 263 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 264 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
| 265 | run_args="${run_args} --verify-soft-fail" |
Andreas Gampe | 825570c | 2015-07-26 10:26:03 -0700 | [diff] [blame] | 266 | image_suffix="-interp-ac" |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 267 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 268 | elif [ "x$1" = "x--no-optimize" ]; then |
| 269 | run_args="${run_args} --no-optimize" |
| 270 | shift |
| 271 | elif [ "x$1" = "x--no-precise" ]; then |
| 272 | run_args="${run_args} --no-precise" |
| 273 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 274 | elif [ "x$1" = "x--invoke-with" ]; then |
| 275 | shift |
| 276 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 277 | if [ "x$what" = "x" ]; then |
| 278 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 279 | usage="yes" |
| 280 | break |
| 281 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 282 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 283 | shift |
| 284 | elif [ "x$1" = "x--dev" ]; then |
| 285 | run_args="${run_args} --dev" |
| 286 | dev_mode="yes" |
| 287 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 288 | elif [ "x$1" = "x--build-only" ]; then |
| 289 | build_only="yes" |
| 290 | shift |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 291 | elif [ "x$1" = "x--build-with-javac-dx" ]; then |
| 292 | USE_JACK="false" |
| 293 | shift |
| 294 | elif [ "x$1" = "x--build-with-jack" ]; then |
| 295 | USE_JACK="true" |
| 296 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 297 | elif [ "x$1" = "x--output-path" ]; then |
| 298 | shift |
| 299 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 300 | if [ "x$tmp_dir" = "x" ]; then |
| 301 | echo "$0 missing argument to --output-path" 1>&2 |
| 302 | usage="yes" |
| 303 | break |
| 304 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 305 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 306 | elif [ "x$1" = "x--android-root" ]; then |
| 307 | shift |
| 308 | if [ "x$1" = "x" ]; then |
| 309 | echo "$0 missing argument to --android-root" 1>&2 |
| 310 | usage="yes" |
| 311 | break |
| 312 | fi |
| 313 | android_root="$1" |
| 314 | run_args="${run_args} --android-root $1" |
| 315 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 316 | elif [ "x$1" = "x--update" ]; then |
| 317 | update_mode="yes" |
| 318 | shift |
| 319 | elif [ "x$1" = "x--help" ]; then |
| 320 | usage="yes" |
| 321 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 322 | elif [ "x$1" = "x--64" ]; then |
| 323 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 324 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 325 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 326 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 327 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 328 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 329 | elif [ "x$1" = "x--stream" ]; then |
| 330 | trace_stream="true" |
| 331 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 332 | elif [ "x$1" = "x--always-clean" ]; then |
| 333 | always_clean="yes" |
| 334 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 335 | elif [ "x$1" = "x--never-clean" ]; then |
| 336 | never_clean="yes" |
| 337 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 338 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
| 339 | run_args="${run_args} --dex2oat-swap" |
| 340 | shift |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 341 | elif [ "x$1" = "x--instruction-set-features" ]; then |
| 342 | shift |
| 343 | run_args="${run_args} --instruction-set-features $1" |
| 344 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 345 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 346 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 347 | usage="yes" |
| 348 | break |
| 349 | else |
| 350 | break |
| 351 | fi |
| 352 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 353 | |
| 354 | # tmp_dir may be relative, resolve. |
| 355 | # |
| 356 | # Cannot use realpath, as it does not exist on Mac. |
| 357 | # Cannot us a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 358 | # Cannot use readlink -m, as it does not exist on Mac. |
| 359 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 360 | noncanonical_tmp_dir=$tmp_dir |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 361 | tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 362 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 363 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 364 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 365 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
| 366 | run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 367 | fi |
| 368 | if [ "$gc_verify" = "true" ]; then |
| 369 | run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc" |
| 370 | fi |
| 371 | if [ "$gc_stress" = "true" ]; then |
Mathieu Chartier | eb19362 | 2015-06-27 15:42:27 -0700 | [diff] [blame] | 372 | run_args="${run_args} --runtime-option -Xgc:SS,gcstress --runtime-option -Xms2m --runtime-option -Xmx16m" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 373 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 374 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 375 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000" |
| 376 | if [ "$trace_stream" = "true" ]; then |
| 377 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 378 | # the ability to analyze the file and just write to /dev/null. |
| 379 | run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null" |
| 380 | # Enable streaming mode. |
| 381 | run_args="${run_args} --runtime-option -Xmethod-trace-stream" |
| 382 | else |
| 383 | run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 384 | fi |
| 385 | elif [ "$trace_stream" = "true" ]; then |
| 386 | echo "Cannot use --stream without --trace." |
| 387 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 388 | fi |
| 389 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 390 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 391 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 392 | function guess_target_arch_name() { |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 393 | grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'` |
Andreas Gampe | 1a5c406 | 2015-01-15 12:10:47 -0800 | [diff] [blame] | 394 | grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'` |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 395 | if [ "x${suffix64}" = "x64" ]; then |
| 396 | target_arch_name=${grep64bit} |
| 397 | else |
| 398 | target_arch_name=${grep32bit} |
| 399 | fi |
| 400 | } |
| 401 | |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 402 | function guess_host_arch_name() { |
| 403 | if [ "x${suffix64}" = "x64" ]; then |
| 404 | host_arch_name="x86_64" |
| 405 | else |
| 406 | host_arch_name="x86" |
| 407 | fi |
| 408 | } |
| 409 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 410 | if [ "$target_mode" = "no" ]; then |
| 411 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 412 | if [ "$prebuild_mode" = "yes" ]; then |
| 413 | echo "--prebuild with --jvm is unsupported"; |
| 414 | exit 1; |
| 415 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 416 | fi |
| 417 | fi |
| 418 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 419 | if [ "$have_patchoat" = "no" ]; then |
| 420 | run_args="${run_args} --no-patchoat" |
| 421 | fi |
| 422 | |
| 423 | if [ "$have_dex2oat" = "no" ]; then |
| 424 | run_args="${run_args} --no-dex2oat" |
| 425 | fi |
| 426 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 427 | if [ ! "$runtime" = "jvm" ]; then |
| 428 | run_args="${run_args} --lib $lib" |
| 429 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 430 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 431 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 432 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 433 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 434 | bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
| 435 | run_args="${run_args} --boot -Xbootclasspath:${bpath}" |
| 436 | else |
| 437 | true # defaults to using target BOOTCLASSPATH |
| 438 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 439 | elif [ "$runtime" = "art" ]; then |
| 440 | if [ "$target_mode" = "no" ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 441 | # ANDROID_HOST_OUT is not set in a build environment. |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 442 | if [ -z "$ANDROID_HOST_OUT" ]; then |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 443 | export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86 |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 444 | fi |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 445 | guess_host_arch_name |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 446 | run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}.art" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 447 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 448 | else |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 449 | guess_target_arch_name |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 450 | run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 451 | run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 452 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 453 | if [ "$relocate" = "yes" ]; then |
| 454 | run_args="${run_args} --relocate" |
| 455 | else |
| 456 | run_args="${run_args} --no-relocate" |
| 457 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 458 | elif [ "$runtime" = "jvm" ]; then |
| 459 | # TODO: Detect whether the host is 32-bit or 64-bit. |
| 460 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 461 | fi |
| 462 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 463 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 464 | if [ "$runtime" != "art" ]; then |
| 465 | echo "--no-image is only supported on the art runtime" |
| 466 | exit 1 |
| 467 | fi |
| 468 | if [ "$target_mode" = "no" ]; then |
| 469 | framework="${ANDROID_HOST_OUT}/framework" |
| 470 | bpath_suffix="-hostdex" |
| 471 | else |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 472 | framework="${android_root}/framework" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 473 | bpath_suffix="" |
| 474 | fi |
| 475 | # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will |
| 476 | # fail since these jar files will be stripped. |
| 477 | bpath="${framework}/core-libart${bpath_suffix}.jar" |
| 478 | bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar" |
| 479 | bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar" |
| 480 | bpath="${bpath}:${framework}/core-junit${bpath_suffix}.jar" |
| 481 | bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar" |
| 482 | # Pass down the bootclasspath |
| 483 | run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 484 | run_args="${run_args} --no-image" |
| 485 | fi |
| 486 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 487 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
| 488 | echo "--dev and --update are mutually exclusive" 1>&2 |
| 489 | usage="yes" |
| 490 | fi |
| 491 | |
| 492 | if [ "$usage" = "no" ]; then |
| 493 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 494 | test_dir=`basename "$oldwd"` |
| 495 | else |
| 496 | test_dir="$1" |
| 497 | fi |
| 498 | |
| 499 | if [ '!' -d "$test_dir" ]; then |
| 500 | td2=`echo ${test_dir}-*` |
| 501 | if [ '!' -d "$td2" ]; then |
| 502 | echo "${test_dir}: no such test directory" 1>&2 |
| 503 | usage="yes" |
| 504 | fi |
| 505 | test_dir="$td2" |
| 506 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 507 | # Shift to get rid of the test name argument. The rest of the arguments |
| 508 | # will get passed to the test run. |
| 509 | shift |
| 510 | fi |
| 511 | |
| 512 | if [ "$usage" = "yes" ]; then |
| 513 | prog=`basename $prog` |
| 514 | ( |
| 515 | echo "usage:" |
| 516 | echo " $prog --help Print this message." |
| 517 | echo " $prog [options] [test-name] Run test normally." |
| 518 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 519 | "(dumps to stdout)." |
| 520 | echo " $prog --update [options] [test-name] Update mode" \ |
| 521 | "(replaces expected.txt)." |
| 522 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 523 | "current directory." |
| 524 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 525 | echo " -O Run non-debug rather than debug build (off by default)." |
| 526 | echo " -Xcompiler-option Pass an option to the compiler." |
| 527 | echo " --runtime-option Pass an option to the runtime." |
| 528 | echo " --debug Wait for a debugger to attach." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 529 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 530 | echo " --gdb Run under gdb; incompatible with some tests." |
| 531 | echo " --build-only Build test files only (off by default)." |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 532 | echo " --build-with-javac-dx Build test files with javac and dx (on by default)." |
| 533 | echo " --build-with-jack Build test files with jack and jill (off by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 534 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 535 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 536 | echo " --optimizing Enable optimizing compiler (default)." |
| 537 | echo " --quick Use Quick compiler (off by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 538 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 539 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 540 | echo " Verification is enabled if neither --no-verify" |
| 541 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 542 | echo " --no-optimize Turn off optimization (on by default)." |
| 543 | echo " --no-precise Turn off precise GC (on by default)." |
| 544 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 545 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 546 | echo " other runtime options are ignored." |
| 547 | echo " --no-dex2oat Run as though dex2oat was failing." |
| 548 | echo " --no-patchoat Run as though patchoat was failing." |
| 549 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 550 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 551 | echo " the test." |
| 552 | echo " --relocate Force the use of relocating in the test, making" |
| 553 | echo " the image and oat files be relocated to a random" |
| 554 | echo " address before running. (default)" |
| 555 | echo " --no-relocate Force the use of no relocating in the test" |
| 556 | echo " --host Use the host-mode virtual machine." |
| 557 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 558 | echo " --dalvik Use Dalvik (off by default)." |
| 559 | echo " --jvm Use a host-local RI virtual machine." |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 560 | echo " --use-java-home Use the JAVA_HOME environment variable" |
| 561 | echo " to find the java compiler and runtime" |
| 562 | echo " (if applicable) to run the test with." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 563 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 564 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 565 | echo " --64 Run the test in 64-bit mode" |
| 566 | echo " --trace Run with method tracing" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 567 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 568 | echo " --gcstress Run with gc stress testing" |
| 569 | echo " --gcverify Run with gc verification" |
| 570 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 571 | echo " --never-clean Keep the test files even if the test succeeds." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 572 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 573 | echo " --dex2oat-swap Use a dex2oat swap file." |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 574 | echo " --instruction-set-features [string]" |
| 575 | echo " Set instruction-set-features for compilation." |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 576 | ) 1>&2 |
| 577 | exit 1 |
| 578 | fi |
| 579 | |
| 580 | cd "$test_dir" |
| 581 | test_dir=`pwd` |
| 582 | |
| 583 | td_info="${test_dir}/${info}" |
| 584 | td_expected="${test_dir}/${expected}" |
| 585 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 586 | if [ ! -r $td_info ]; then |
| 587 | echo "${test_dir}: missing file $td_info" 1>&2 |
| 588 | exit 1 |
| 589 | fi |
| 590 | |
| 591 | if [ ! -r $td_expected ]; then |
| 592 | echo "${test_dir}: missing file $td_expected" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 593 | exit 1 |
| 594 | fi |
| 595 | |
| 596 | # copy the test to a temp dir and run it |
| 597 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 598 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 599 | |
| 600 | rm -rf "$tmp_dir" |
| 601 | cp -Rp "$test_dir" "$tmp_dir" |
| 602 | cd "$tmp_dir" |
| 603 | |
| 604 | if [ '!' -r "$build" ]; then |
| 605 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 606 | else |
| 607 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 608 | fi |
| 609 | |
| 610 | if [ '!' -r "$run" ]; then |
| 611 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 612 | else |
| 613 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 614 | fi |
| 615 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 616 | if [ '!' -r "$check_cmd" ]; then |
| 617 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 618 | else |
| 619 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 620 | fi |
| 621 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 622 | chmod 755 "$build" |
| 623 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 624 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 625 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 626 | export TEST_NAME=`basename ${test_dir}` |
| 627 | |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 628 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 629 | # Checker when compiled with Optimizing on host. |
| 630 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
| 631 | # Build Checker DEX files without dx's optimizations so the input to dex2oat |
| 632 | # better resembles the Java source. We always build the DEX the same way, even |
| 633 | # if Checker is not invoked and the test only runs the program. |
| 634 | build_args="${build_args} --dx-option --no-optimize" |
| 635 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 636 | # Jack does not necessarily generate the same DEX output than dx. Because these tests depend |
| 637 | # on a particular DEX output, keep building them with dx for now (b/19467889). |
| 638 | USE_JACK="false" |
| 639 | |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 640 | if [ "$runtime" = "art" -a "$image_suffix" = "-optimizing" ]; then |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 641 | # In no-prebuild mode, the compiler is only invoked if both dex2oat and |
| 642 | # patchoat are available. Disable Checker otherwise (b/22552692). |
| 643 | if [ "$prebuild_mode" = "yes" ] || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then |
| 644 | run_checker="yes" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 645 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 646 | if [ "$target_mode" = "no" ]; then |
| 647 | cfg_output_dir="$tmp_dir" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 648 | checker_args="--arch=${host_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 649 | else |
| 650 | cfg_output_dir="$DEX_LOCATION" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 651 | checker_args="--arch=${target_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 652 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 653 | |
| 654 | if [ "$debuggable" = "yes" ]; then |
| 655 | checker_args="$checker_args --debuggable" |
| 656 | fi |
| 657 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 658 | run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \ |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 659 | -Xcompiler-option -j1" |
| 660 | fi |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 661 | fi |
| 662 | fi |
| 663 | |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 664 | if [ "$runtime" != "jvm" ]; then |
| 665 | run_args="${run_args} --testlib ${testlib}" |
| 666 | fi |
| 667 | |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 668 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB. |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 669 | build_file_size_limit=2048 |
| 670 | run_file_size_limit=2048 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 671 | if echo "$test_dir" | grep 089; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 672 | build_file_size_limit=5120 |
| 673 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 674 | elif echo "$test_dir" | grep 083; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 675 | build_file_size_limit=5120 |
| 676 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 677 | fi |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 678 | if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then |
| 679 | # We will need to `adb pull` the .cfg output from the target onto the host to |
| 680 | # run checker on it. This file can be big. |
| 681 | build_file_size_limit=16384 |
| 682 | run_file_size_limit=16384 |
| 683 | fi |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 684 | if [ ${USE_JACK} = "false" ]; then |
| 685 | # Set ulimit if we build with dx only, Jack can generate big temp files. |
| 686 | if ! ulimit -S "$build_file_size_limit"; then |
| 687 | echo "ulimit file size setting failed" |
| 688 | fi |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 689 | fi |
| 690 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 691 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 692 | good_build="yes" |
| 693 | good_run="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 694 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 695 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 696 | build_exit="$?" |
| 697 | echo "build exit status: $build_exit" 1>&2 |
| 698 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 699 | if ! ulimit -S "$run_file_size_limit"; then |
| 700 | echo "ulimit file size setting failed" |
| 701 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 702 | echo "${test_dir}: running..." 1>&2 |
| 703 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 704 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 705 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 706 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 707 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 708 | if [ "$target_mode" = "yes" ]; then |
| 709 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 710 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 711 | "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1 |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 712 | checker_exit="$?" |
| 713 | if [ "$checker_exit" = "0" ]; then |
| 714 | good="yes" |
| 715 | fi |
| 716 | echo "checker exit status: $checker_exit" 1>&2 |
| 717 | else |
| 718 | good="yes" |
| 719 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 720 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 721 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 722 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 723 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 724 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 725 | build_exit="$?" |
| 726 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 727 | if ! ulimit -S "$run_file_size_limit"; then |
| 728 | echo "ulimit file size setting failed" |
| 729 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 730 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 731 | "./${run}" $run_args "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 732 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 733 | if [ "$target_mode" = "yes" ]; then |
| 734 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 735 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 736 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 737 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 738 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 739 | good="yes" |
| 740 | else |
| 741 | cat "$build_output" 1>&2 |
| 742 | echo "build exit status: $build_exit" 1>&2 |
| 743 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 744 | elif [ "$build_only" = "yes" ]; then |
| 745 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 746 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 747 | build_exit="$?" |
| 748 | if [ "$build_exit" '!=' '0' ]; then |
| 749 | cp "$build_output" "$output" |
| 750 | echo "build exit status: $build_exit" >>"$output" |
| 751 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 752 | if [ "$?" '!=' "0" ]; then |
| 753 | good="no" |
| 754 | echo "BUILD FAILED For ${TEST_NAME}" |
| 755 | fi |
| 756 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 757 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 758 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 759 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 760 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 761 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 762 | build_exit="$?" |
| 763 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 764 | if ! ulimit -S "$run_file_size_limit"; then |
| 765 | echo "ulimit file size setting failed" |
| 766 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 767 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 768 | "./${run}" $run_args "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 769 | run_exit="$?" |
| 770 | if [ "$run_exit" != "0" ]; then |
| 771 | echo "run exit status: $run_exit" 1>&2 |
| 772 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 773 | elif [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 774 | if [ "$target_mode" = "yes" ]; then |
| 775 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 776 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 777 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 778 | checker_exit="$?" |
| 779 | if [ "$checker_exit" != "0" ]; then |
| 780 | echo "checker exit status: $checker_exit" 1>&2 |
| 781 | good_run="no" |
| 782 | else |
| 783 | good_run="yes" |
| 784 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 785 | else |
| 786 | good_run="yes" |
| 787 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 788 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 789 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 790 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 791 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 792 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 793 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 794 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 795 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 796 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 797 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 798 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 799 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 800 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 801 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 802 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 803 | # output == expected |
| 804 | good="yes" |
| 805 | echo "${test_dir}: succeeded!" 1>&2 |
| 806 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 807 | fi |
| 808 | fi |
| 809 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 810 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 811 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 812 | echo "${test_dir}: FAILED!" |
| 813 | echo ' ' |
| 814 | echo '#################### info' |
| 815 | cat "${td_info}" | sed 's/^/# /g' |
| 816 | echo '#################### diffs' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 817 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 818 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 819 | if [ "$strace" = "yes" ]; then |
| 820 | echo '#################### strace output' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 821 | tail -n 3000 "$tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 822 | echo '####################' |
| 823 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 824 | echo ' ' |
| 825 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 826 | |
| 827 | ) 1>&2 |
| 828 | |
| 829 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 830 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 831 | cd "$oldwd" |
| 832 | rm -rf "$tmp_dir" |
| 833 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
| 834 | adb shell rm -rf $DEX_LOCATION |
| 835 | fi |
| 836 | if [ "$good" = "yes" ]; then |
| 837 | exit 0 |
| 838 | fi |
| 839 | fi |
| 840 | |
| 841 | |
| 842 | ( |
| 843 | if [ "$always_clean" = "yes" ]; then |
| 844 | echo "${TEST_NAME} files deleted from host " |
| 845 | if [ "$target_mode" == "yes" ]; then |
| 846 | echo "and from target" |
| 847 | fi |
| 848 | else |
| 849 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 850 | if [ "$target_mode" == "yes" ]; then |
| 851 | echo "and in ${DEX_LOCATION} on target" |
| 852 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 853 | fi |
| 854 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 855 | ) 1>&2 |
| 856 | |
| 857 | exit 1 |